/*!
 * \file      UpperTesterCamFactory.hh
 * \brief     Header file for ITS CAM Upper Tester protocol layer factory.
 * \author    ETSI STF525
 * \copyright ETSI Copyright Notification
 *            No part may be reproduced except as authorized by written permission.
 *            The copyright and the foregoing restriction extend to reproduction in all media.
 *            All rights reserved.
 * \version   0.1
 */
#pragma once

#include "LayerStackBuilder.hh"

#include "UpperTesterCamLayer.hh"

class UpperTesterCamFactory : public LayerFactory {
  static UpperTesterCamFactory _f;
public:
  UpperTesterCamFactory() {
    // Register factory
    loggers::get_instance().log(">>> UpperTesterCamFactory::UpperTesterCamFactory");
    LayerStackBuilder::RegisterLayerFactory("UT_CAM", this);
  };
  inline virtual Layer * createLayer(const std::string& p_type, const std::string& p_param){
    return new UpperTesterCamLayer(p_type, p_param);
  };
}; // End of class UpperTesterCamFactory
